SystemOrganization addCategory: #ConfigurationOfScriptManager!

Object subclass: #ConfigurationOfScriptManager
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfScriptManager'!

!ConfigurationOfScriptManager class methodsFor: 'private' stamp: 'tbn 1/26/2010 09:50'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfScriptManager class methodsFor: 'private' stamp: 'tbn 1/26/2010 09:50'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfScriptManager class methodsFor: 'metacello tool support' stamp: 'tbn 1/26/2010 09:50'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfScriptManager class methodsFor: 'metacello tool support' stamp: 'tbn 1/26/2010 09:50'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfScriptManager class methodsFor: 'loading' stamp: 'tbn 1/26/2010 09:50'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfScriptManager class methodsFor: 'metacello tool support' stamp: 'tbn 1/26/2010 09:50'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfScriptManager class methodsFor: 'accessing' stamp: 'tbn 1/26/2010 09:50'!
project

	^self new project! !

!ConfigurationOfScriptManager methodsFor: 'baselines' stamp: 'tbn 1/26/2010 09:53'!
baseline100: spec 
	<version: '1.0-baseline'>
	
	spec for: #pharo do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/ScriptManager'.	
		spec 
			package: 'ScriptManager-Core'.
		spec
			group: 'default' with: #('Core');
			group: 'Core' with: #('ScriptManager-Core')].! !

!ConfigurationOfScriptManager methodsFor: 'accessing' stamp: 'tbn 1/26/2010 09:50'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfScriptManager methodsFor: 'versions' stamp: 'tbn 2/2/2010 12:39'!
version100: spec 
	<version: '1.0' imports: #('1.0-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'ScriptManager-Core' with: 'ScriptManager-Core-tbn.8'].! !
